"""
exM-1.py

B(E)3M33UI - Artificial Intelligence course, FEE CTU in Prague
Neural Networks

Petr Posik, CVUT, Praha 2017
"""

import numpy as np
from matplotlib import pyplot as plt
from sklearn.neural_network import MLPClassifier

from plotting import plot_2D_class_model, plot_xy_classified_data


def main():

    # Load data
    data = np.loadtxt('data_1.csv', delimiter=',')
    # data = np.loadtxt('data_xor_rect.csv', delimiter=',')

    print(data.shape)

    X = data[:, 0:2]
    y = data[:, 2].astype(int)

    print('\nThe dataset (X and y) size:')
    print('X: ', X.shape)
    print('y: ', y.shape)
    print('sum(y = 0): ', sum(y == 0))
    print('sum(y = 1): ', sum(y == 1))

    plot_xy_classified_data(X[:, 0], X[:, 1], y)

    # # FIXME Task 6: Implement backpropagation
    # raise NotImplementedError
    # <YOUR CODE HERE>

    # # FIXME Task 7: Visualize decision boundary
    # raise NotImplementedError
    # <YOUR CODE HERE>

    # # FIXME Task 8: MLPClassifier
    # raise NotImplementedError
    # <YOUR CODE HERE>

    # # FIXME Task 9: MLPClassifier
    # raise NotImplementedError
    # <YOUR CODE HERE>

# catch all exceptions
try:
    plt.ion()  # turn interactive mode on so our plots stay open like in matlab
    main()

except BaseException as e:
    import traceback
    traceback.print_exc()  # mimic printing traceback from an exception
    plt.ioff()  # turn interactive mode off
    plt.show()  # show whatever we have to show, it will stay open because we turned interactive mode off

